unit dlgAboutBox;

// The contents of this file are subject to the Mozilla Public License Version
// 1.1 (the "License"); you may not use this file except in compliance with
// the License. You may obtain a copy of the License at
// "http://www.mozilla.org/MPL/"
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// The Original Code is "dlgAboutBox.pas".
// 
// The Initial Developer of the Original Code is Dieter Khler (Heidelberg, 
// Germany, "http://www.philo.de/").
// Portions created by the Initial Developer are Copyright (C) 2009
// Dieter Khler. All Rights Reserved.
// 
// Alternatively, the contents of this file may be used under the terms of
// the GNU General Public License Version 2 or later (the "GPL"), in which 
// case the provisions of the GPL are applicable instead of those above. 
// If you wish to allow use of your version of this file only under the 
// terms of the GPL, and not to allow others to use your version of this 
// file under the terms of the MPL, indicate your decision by deleting the
// provisions above and replace them with the notice and other provisions 
// required by the GPL. If you do not delete the provisions above, a 
// recipient may use your version of this file under the terms of any one 
// of the MPL or the GPL.

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ShellAPI;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProductName: TLabel;
    VersionLabel: TLabel;
    Copyright: TLabel;
    Label3: TLabel;
    OKButton: TButton;
    UrlLabel: TLabel;
    Label4: TLabel;
    Timer: TTimer;
    procedure UrlLabelClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowSplash;
  end;

implementation

{$R *.dfm}

uses
  uVersionCheck;

procedure TAboutBox.UrlLabelClick(Sender: TObject);
var
  TempString: array[0..79] of char;
begin
  StrPCopy(TempString,UrlLabel.Caption);
  ShellExecute(0,nil,TempString,nil,nil,SW_NORMAL);
end;

procedure TAboutBox.TimerTimer(Sender: TObject);
begin
  Close;
  Release;
end;

procedure TAboutBox.FormCreate(Sender: TObject);
var
  S: string;
begin
  // Retrieve version info:
  S := GetFileVersionStr(Application.ExeName, vdAll);
  if S <> ''
    then VersionLabel.Caption := 'Version ' + S
    else VersionLabel.Caption := '';

  // Center horizontally:
  VersionLabel.Left := (VersionLabel.Parent.Width - VersionLabel.Width) div 2;
end;

procedure TAboutBox.ShowSplash;
begin
  BorderStyle := bsToolWindow;
  Caption := '';
  OKButton.Visible := False;
  Height := 168;
  FormStyle := fsStayOnTop;
  Show;
  Update;
  Timer.Enabled := True;
      // Remark: When the time has elapsed the AboutBox closes and releases itself.
end;

end.

