// The contents of this file are subject to the Mozilla Public License Version
// 1.1 (the "License"); you may not use this file except in compliance with
// the License. You may obtain a copy of the License at
// "http://www.mozilla.org/MPL/"
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// The Original Code is "dlgProxyPassword.pas".
//
// The Initial Developer of the Original Code is Dieter Khler (Heidelberg,
// Germany, "http://www.philo.de/").
// Portions created by the Initial Developer are Copyright (C) 2004
// Dieter Khler. All Rights Reserved.
//
// Alternatively, the contents of this file may be used under the terms of
// the GNU General Public License Version 2 or later (the "GPL"), in which
// case the provisions of the GPL are applicable instead of those above.
// If you wish to allow use of your version of this file only under the
// terms of the GPL, and not to allow others to use your version of this
// file under the terms of the MPL, indicate your decision by deleting the
// provisions above and replace them with the notice and other provisions
// required by the GPL. If you do not delete the provisions above, a
// recipient may use your version of this file under the terms of any one
// of the MPL or the GPL.

unit dlgProxyPassword;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TProxyPasswordDlg = class(TForm)
    Label1: TLabel;
    PasswordEdit: TEdit;
    OKBtn: TButton;
    CancelBtn: TButton;
    UsernameEdit: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    StorePasswordRadioGroup: TRadioGroup;
  private
    function GetStoreHttpProxyPassword: Integer;
    procedure SetStoreHttpProxyPassword(const Value: Integer);
    function GetHttpProxyPassword: string;
    function GetHttpProxyUsername: string;
    procedure SetHttpProxyPassword(const Value: string);
    procedure SetHttpProxyUsername(const Value: string);
  public
    property HttpProxyPassword: string read GetHttpProxyPassword write SetHttpProxyPassword;
    property HttpProxyUsername: string read GetHttpProxyUsername write SetHttpProxyUsername;
    property StoreHttpProxyPassword: Integer read GetStoreHttpProxyPassword write SetStoreHttpProxyPassword;
  end;

implementation

{$R *.dfm}

{ TProxyPasswordDlg }

function TProxyPasswordDlg.GetHttpProxyPassword: string;
begin
  Result := PasswordEdit.Text;
end;

function TProxyPasswordDlg.GetHttpProxyUsername: string;
begin
  Result := UsernameEdit.Text;
end;

function TProxyPasswordDlg.GetStoreHttpProxyPassword: Integer;
begin
  Result := StorePasswordRadioGroup.ItemIndex;
end;

procedure TProxyPasswordDlg.SetHttpProxyPassword(const Value: string);
begin
   PasswordEdit.Text := Value;
end;

procedure TProxyPasswordDlg.SetHttpProxyUsername(const Value: string);
begin
   UsernameEdit.Text := Value;
end;

procedure TProxyPasswordDlg.SetStoreHttpProxyPassword(
  const Value: Integer);
begin
  StorePasswordRadioGroup.ItemIndex := Value;
end;

end.
 
