// The contents of this file are subject to the Mozilla Public License Version
// 1.1 (the "License"); you may not use this file except in compliance with
// the License. You may obtain a copy of the License at
// "http://www.mozilla.org/MPL/"
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// The Original Code is "frmMain.pas".
//
// The Initial Developer of the Original Code is Dieter Khler (Heidelberg,
// Germany, "http://www.philo.de/").
// Portions created by the Initial Developer are Copyright (C) 2003-2009
// Dieter Khler. All Rights Reserved.
//
// Alternatively, the contents of this file may be used under the terms of
// the GNU General Public License Version 2 or later (the "GPL"), in which
// case the provisions of the GPL are applicable instead of those above.
// If you wish to allow use of your version of this file only under the
// terms of the GPL, and not to allow others to use your version of this
// file under the terms of the MPL, indicate your decision by deleting the
// provisions above and replace them with the notice and other provisions
// required by the GPL. If you do not delete the provisions above, a
// recipient may use your version of this file under the terms of any one
// of the MPL or the GPL.
//
// -----------------------------------------------------------------------
//
// Acknowledgement: Parts of the code, as indicated below, are taken from
// the EditAppDemos project, written by Michael Hieke for the SynEdit
// component suite (see "http://SynEdit.SourceForge.net").

unit frmMain;

// {$I SynEdit.inc}

interface

uses
  AutoStrCtrls, uXmlTabCtrls, dkAdomCore, AdomNetwork_5_1, uVersionCheck,
  VShellTree, IdAuthentication, Forms, ActnPopup, ImgList, AppLauncher,
  PlatformDefaultStyleActnCtrls, AppEvnts, Menus, Controls, Classes, ActnList,
  ExtCtrls, Dialogs, ActnMan, ActnCtrls, ToolWin, ActnMenus, ComCtrls, StdCtrls;

type
  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    ActionManager: TActionManager;
    actlFile: TActionList;
    actFileNew: TAction;
    actFileOpen: TAction;
    actFileCloseAll: TAction;
    actFileExit: TAction;
    imglFile: TImageList;
    MainPanel: TPanel;
    MainPanelSplitter: TSplitter;
    MessageAutoListBox: TAutoStrListBox;
    imglTools: TImageList;
    actlView: TActionList;
    actViewStatusbar: TAction;
    actUpdateStatusBarPanels: TAction;
    actFileSave: TAction;
    actFileSaveAs: TAction;
    actFileClose: TAction;
    actFilePrint: TAction;
    MainActionMenuBar: TActionMainMenuBar;
    actlTools: TActionList;
    actCheckWellformedness: TAction;
    actCheckValidity: TAction;
    XmlEditPageControl: TXmlEditPageControl;
    imglEditSearch: TImageList;
    ButtonBar: TActionToolBar;
    actViewButtonBar: TAction;
    actlEditSearch: TActionList;
    actEditUndo: TAction;
    actEditRedo: TAction;
    actEditCut: TAction;
    actEditCopy: TAction;
    actEditPaste: TAction;
    actEditDelete: TAction;
    actSearchFind: TAction;
    actSearchFindNext: TAction;
    actSearchFindPrev: TAction;
    actSearchReplace: TAction;
    actEditSelectAll: TAction;
    MainPopupActionBarEx: TPopupActionBar;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Print1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    FindPrevious1: TMenuItem;
    Replace1: TMenuItem;
    N5: TMenuItem;
    WellformednessTest1: TMenuItem;
    Validate1: TMenuItem;
    Delete1: TMenuItem;
    N6: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    actViewMessages: TAction;
    ReopenActionList: TActionList;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    Action4: TAction;
    Action5: TAction;
    Action6: TAction;
    Action7: TAction;
    Action8: TAction;
    Action9: TAction;
    Action10: TAction;
    actFilePageSetup: TAction;
    actFilePrintPreview: TAction;
    actFilePrinterSetup: TAction;
    PrintPreview1: TMenuItem;
    N7: TMenuItem;
    MessagePanel1: TMenuItem;
    actHelpAbout: TAction;
    PrinterSetupDialog: TPrinterSetupDialog;
    actViewPreferences: TAction;
    OpenDialog: TOpenDialog;
    VersionChecker: TVersionChecker;
    actHelpCheckNewVersion: TAction;
    Close1: TMenuItem;
    CloseAllFiles1: TMenuItem;
    IndyResourceResolver: TIndyResourceResolver;
    actFileReload: TAction;
    N8: TMenuItem;
    Reload1: TMenuItem;
    ApplicationEvents: TApplicationEvents;
    ToolsControlSplitter: TSplitter;
    EditPanel: TPanel;
    ToolsPageControl: TPageControl;
    FileSystemExplorerTabSheet: TTabSheet;
    actViewFileSystemExplorer: TAction;
    VirtualShellTree: TVirtualShellTree;
    AppLauncher: TAppLauncher;
    actLaunchSaxon: TAction;
    LaunchSaxon1: TMenuItem;
    procedure actCheckValidityExecute(Sender: TObject);
    procedure actCheckValidityUpdate(Sender: TObject);
    procedure actCheckWellformednessExecute(Sender: TObject);
    procedure actCheckWellformednessUpdate(Sender: TObject);
    procedure actFileCloseExecute(Sender: TObject);
    procedure actFileCloseUpdate(Sender: TObject);
    procedure actFileCloseAllExecute(Sender: TObject);
    procedure actFileCloseAllUpdate(Sender: TObject);
    procedure actFileExitExecute(Sender: TObject);
    procedure actFileNewExecute(Sender: TObject);
    procedure actFileNewUpdate(Sender: TObject);
    procedure actFileOpenExecute(Sender: TObject);
    procedure actFileOpenUpdate(Sender: TObject);
    procedure actFilePageSetupExecute(Sender: TObject);
    procedure actFilePageSetupUpdate(Sender: TObject);
    procedure actFilePrinterSetupExecute(Sender: TObject);
    procedure actFilePrinterSetupUpdate(Sender: TObject);
    procedure actFilePrintPreviewExecute(Sender: TObject);
    procedure actFilePrintPreviewUpdate(Sender: TObject);
    procedure actFilePrintExecute(Sender: TObject);
    procedure actFilePrintUpdate(Sender: TObject);
    procedure actFileReloadExecute(Sender: TObject);
    procedure actFileReloadUpdate(Sender: TObject);
    procedure actFileReopenExecute(Sender: TObject);
    procedure actFileSaveExecute(Sender: TObject);
    procedure actFileSaveUpdate(Sender: TObject);
    procedure actFileSaveAsExecute(Sender: TObject);
    procedure actFileSaveAsUpdate(Sender: TObject);
    procedure actEditCutExecute(Sender: TObject);
    procedure actEditCutUpdate(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditCopyUpdate(Sender: TObject);
    procedure actEditPasteExecute(Sender: TObject);
    procedure actEditPasteUpdate(Sender: TObject);
    procedure actEditDeleteExecute(Sender: TObject);
    procedure actEditDeleteUpdate(Sender: TObject);
    procedure actEditSelectAllExecute(Sender: TObject);
    procedure actEditSelectAllUpdate(Sender: TObject);
    procedure actEditRedoExecute(Sender: TObject);
    procedure actEditRedoUpdate(Sender: TObject);
    procedure actEditUndoExecute(Sender: TObject);
    procedure actEditUndoUpdate(Sender: TObject);
    procedure actSearchFindExecute(Sender: TObject);
    procedure actSearchFindUpdate(Sender: TObject);
    procedure actSearchFindNextExecute(Sender: TObject);
    procedure actSearchFindNextUpdate(Sender: TObject);
    procedure actSearchFindPrevExecute(Sender: TObject);
    procedure actSearchFindPrevUpdate(Sender: TObject);
    procedure actSearchReplaceExecute(Sender: TObject);
    procedure actSearchReplaceUpdate(Sender: TObject);
    procedure actUpdateStatusBarPanelsUpdate(Sender: TObject);
    procedure actViewButtonBarExecute(Sender: TObject);
    procedure actViewButtonBarUpdate(Sender: TObject);
    procedure actViewFileSystemExplorerExecute(Sender: TObject);
    procedure actViewFileSystemExplorerUpdate(Sender: TObject);
    procedure actViewMessagesExecute(Sender: TObject);
    procedure actViewMessagesUpdate(Sender: TObject);
    procedure actViewStatusBarExecute(Sender: TObject);
    procedure actViewStatusBarUpdate(Sender: TObject);
    procedure actViewPreferencesExecute(Sender: TObject);
    procedure actHelpAboutExecute(Sender: TObject);
    procedure actHelpAboutUpdate(Sender: TObject);
    procedure actHelpCheckNewVersionUpdate(Sender: TObject);
    procedure actHelpCheckNewVersionExecute(Sender: TObject);

    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MessageAutoListBoxDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ProxyAuthorization(Sender: TObject;
      Authentication: TIdAuthentication; var Handled: Boolean);
    procedure XmlEditPageControlEditorChange(Sender: TObject);
    procedure XmlEditPageControlSaved(Sender: TObject; const OldUri,
      NewUri: WideString);
    procedure XmlEditPageControlTabChange(Sender: TObject);
    procedure VersionCheckerCompleted(Sender: TObject;
      VCResult: TVersionCheckerResult);
    procedure ApplicationEventsActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure VirtualShellTreeFileDblClick(Sender: TObject;
      FullPath: WideString; Attributes: Cardinal);
    procedure XmlEditPageControlSetupHexEditorRequest(Sender: TObject);
    procedure actLaunchSaxonUpdate(Sender: TObject);
    procedure actLaunchSaxonExecute(Sender: TObject);
    procedure XmlEditPageControlSaxonLaunching(Sender: TObject);
  private
    FOpenToolItem: TActionClientItem;
    FReopenMenuItem: TActionClientItem;
    FVCFirstAttempt: Boolean;
    procedure AddMRUEntry(const S: string);
    procedure FindOpenToolItem(AClient: TActionClient);
    procedure FindReopenMenuItem(AClient: TActionClient);
    procedure ForgetHttpProxyPwd(Sender: TObject);
    function GetApplicationDataFolder: string;
    function GetDataFolder: string;
    function GetIniFileName: string;
    procedure RemoveMRUEntry(const S: string);
    procedure ShowPreferencesDlg(const AActivePageIndex: Integer);
    procedure UpdateProxySetting;
    procedure UpdateReopenItem(const ReopenItem: TActionClientItem);
  protected
    procedure AutoShowMessagePanel;
    procedure CaretMoveToError;
    function CmdLineOpenFiles(AMultipleFiles: boolean): Boolean;
    function OpenFile(AFileName: string): Boolean;
    procedure OpenFiles(const Files: TStrings);
    function OpenUri(SysId: WideString): Boolean; virtual;   // xxx Require absolute URLs or allow relative ones as well?
    procedure ReadIniSettings;
    procedure ReadPublicIdMappings;
    procedure WriteIniSettings;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  dlgAboutBox, dlgPreferences, dlgProxyPassword,
  uXmlEditTypes,
  dkUriUtils, AdomErrorReporting_5_1,
  IniFiles, SHFolder, Math, SysUtils, Windows;

resourcestring
  SCreateDataDirectoryFailed = 'Cannot create data directory (%s)';

  SAskReload = 'Do you really want to reload the file?';
  SReloadFailed = 'Cannot reload document';

  SIsValid = 'The document is valid.';
  SIsNotValid = 'The document is not valid.';
  SIsWellformed = 'No violations of wellformedness constraints detected.';
  SIsNotWellformed = 'The document is not wellformed.';

  SModified = 'Modified';
  SXsltRunning = 'XSLT running';

  SNotFound = '"%s" not found.';

  SFilterMaskAllFiles = 'All files|*.*';
  SFilterMaskXmlFiles = 'XML files (*.xml; *.xsd; *.xsl; *.xslt)|*.xml;*.xsd;*.xsl;*.xslt';

  SNetworkError = 'A network error occurred';
  SNewVersionAvailable =  'A new version of the Open XML Editor is available for download at ''http://www.philo.de/xmledit/''.';
  SNoNewVersionAvailable =  'There is no new version of the Open XML Editor available.';

{ TMainForm }

// Event handlers

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := XmlEditPageControl.CanCloseAll;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  SplashBox: TAboutBox;
begin
  SplashBox := TAboutBox.Create(Self);
  SplashBox.ShowSplash; // Remark: When the time has elapsed the splash box closes and releases itself.

  VirtualShellTree.TopFolders := [vsfPersonal, vsfDrives, vsfNetwork, vsfDesktopDirectory];

  MessageAutoListBox.Iterator := XmlEditPageControl.ErrorStringIterator;

  // Create the directory for the ini-file if it not already exists: 
  if not DirectoryExists(GetDataFolder) then
    if not CreateDir(GetDataFolder) then
      ShowMessage(Format(SCreateDataDirectoryFailed, [GetDataFolder]));

  ReadIniSettings;
  ReadPublicIdMappings;
  UpdateProxySetting;
  if not CmdLineOpenFiles(True) then
    XmlEditPageControl.AddEmptyDoc;  // xxx Move into TXmlEditPageControl?
  AutoShowMessagePanel;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  MessageAutoListBox.Iterator := nil;
  XmlEditPageControl.CloseAll;
  WriteIniSettings;
end;

procedure TMainForm.ProxyAuthorization(Sender: TObject;
  Authentication: TIdAuthentication; var Handled: Boolean);
const
  MAX_RETRIES: Integer = 2;
var
  IniFile: TIniFile;
  ProxyPasswordDlg: TProxyPasswordDlg;
begin
  if (Authentication.CurrentStep = 0) and
     ((UserPreferences.HttpProxyUsername <> '') or (UserPreferences.HttpProxyPassword <> '')) and
     (UserPreferences.StoreHttpProxyPassword <> 2)
  then begin
    Authentication.Username := UserPreferences.HttpProxyUsername;
    Authentication.Password := UserPreferences.HttpProxyPassword;
    Handled := True;
  end else if (Authentication.CurrentStep > MAX_RETRIES) then begin
    Handled := False;
  end else begin
    ProxyPasswordDlg := TProxyPasswordDlg.Create(Self);
    try
      ProxyPasswordDlg.StoreHttpProxyPassword := UserPreferences.StoreHttpProxyPassword;
      ProxyPasswordDlg.UsernameEdit.Text := UserPreferences.HttpProxyUsername;
      if ProxyPasswordDlg.ShowModal = mrOk then begin
        Authentication.Username := ProxyPasswordDlg.HttpProxyUsername;
        Authentication.Password := ProxyPasswordDlg.HttpProxyPassword;
        if UserPreferences.StoreHttpProxyPassword <> ProxyPasswordDlg.StoreHttpProxyPassword then begin
          UserPreferences.StoreHttpProxyPassword := ProxyPasswordDlg.StoreHttpProxyPassword;
          if UserPreferences.StoreHttpProxyPassword <> 0 then begin
            // Immediately delete the password from the Ini-file:
            IniFile := TIniFile.Create(GetIniFileName);
            try
              IniFile.WriteInteger('Preferences', 'StoreHttpProxyPassword', UserPreferences.StoreHttpProxyPassword);
              IniFile.WriteString('Preferences', 'HttpProxyUsername', '');
              IniFile.WriteString('Preferences', 'HttpProxyPassword', '');
            finally
              IniFile.Free;
            end;
            if UserPreferences.StoreHttpProxyPassword = 2 then begin
              UserPreferences.HttpProxyUsername := '';
              UserPreferences.HttpProxyPassword := '';
            end;
          end;
        end;
        if UserPreferences.StoreHttpProxyPassword < 3 then begin
          UserPreferences.HttpProxyUsername := ProxyPasswordDlg.HttpProxyUsername;
          UserPreferences.HttpProxyPassword := ProxyPasswordDlg.HttpProxyPassword;
        end;
        Handled := True;
      end else Handled := False;
    finally
      ProxyPasswordDlg.Free;
    end;
  end;
end;

procedure TMainForm.XmlEditPageControlEditorChange(Sender: TObject);
begin
  AutoShowMessagePanel;
  CaretMoveToError;
end;

procedure TMainForm.XmlEditPageControlSaved(Sender: TObject; const OldUri,
  NewUri: WideString);
begin
  if NewUri <> OldUri then
    AddMRUEntry(NewUri)
end;

procedure TMainForm.XmlEditPageControlSaxonLaunching(Sender: TObject);
begin
  actLaunchSaxon.Update;
  actUpdateStatusBarPanels.Update;
end;

procedure TMainForm.XmlEditPageControlSetupHexEditorRequest(Sender: TObject);
begin
  ShowPreferencesDlg(2);
end;

procedure TMainForm.XmlEditPageControlTabChange(Sender: TObject);
begin
  if Active then
    XmlEditPageControl.FocusEditor;
end;

procedure TMainForm.MessageAutoListBoxDblClick(Sender: TObject);
begin
  CaretMoveToError;
end;

// Helper methods

procedure TMainForm.AddMRUEntry(const S: string);
var
  I, N: Integer;
begin
  if S = '' then Exit;
  // Add thew new filename to the beginning of the list and move other items
  // down. If the filename is already in the list, then do not add it again,
  // but move it to the beginning:
  N := -1;
  with ReopenActionList do begin
    repeat
      Inc(N);
      if CompareText(TCustomAction(Actions[N]).Caption, S) = 0 then
        Break;
    until N = Pred(ActionCount);

    for I := N downto 0 do
      if I = 0
        then TCustomAction(Actions[I]).Caption := S
        else TCustomAction(Actions[I]).Caption := TCustomAction(Actions[I - 1]).Caption;
  end;
  // Update the menu entries:
  UpdateReopenItem(FReopenMenuItem);
//UpdateReopenItem(FOpenToolItem);  // xxx Disabled, because due to a bug in Delphi 7 the button is not rendered correctly.
end;

procedure TMainForm.AutoShowMessagePanel;
var
  I: Integer;
begin
  try
    if MessageAutoListBox.Visible then begin
      // Test whether one of the open editors has error messages attached:
      with XmlEditPageControl do
        for I := 0 to Pred(PageCount) do
          if Pages[I].HasErrorStrings then Exit;
      MessageAutoListBox.Visible := False;
      MainPanelSplitter.Visible := False;
    end else begin
      if MessageAutoListBox.Count > 0 then begin
        MessageAutoListBox.Visible := True;
        MainPanelSplitter.Visible := True;
      end;
    end;
  finally  // Remark: Finally catches the above Exit command.
    if Assigned(MessageAutoListBox.Iterator) then begin
      if MessageAutoListBox.Iterator.Offlist then
        MessageAutoListBox.Iterator.First;
    end;
  end;
end;

procedure TMainForm.CaretMoveToError;
begin
  if Assigned(MessageAutoListBox.Iterator) then
    if not MessageAutoListBox.Iterator.Offlist then
      with XmlEditPageControl do
        if SetCaret((MessageAutoListBox.Iterator.List as TDomErrorAutoStrings).Errors[MessageAutoListBox.Iterator.Position]) then
          FocusEditor;
end;

function TMainForm.CmdLineOpenFiles(AMultipleFiles: boolean): boolean;
// Code taken from the EditAppDemos project, written by
// Michael Hieke for the SynEdit component suite
// (see "http://SynEdit.SourceForge.net").
var
  I, Cnt: Integer;
begin
  Cnt := ParamCount;
  if Cnt > 0 then begin
    if not AMultipleFiles and (Cnt > 1) then
      Cnt := 1;
    for I := 1 to Cnt do
       OpenFile(ParamStr(I));
    Result := True;
  end else
    Result := False;
end;

procedure TMainForm.FindOpenToolItem(AClient: TActionClient);
begin
  // Find the Open item by looking at the item caption
  if AClient is TActionClientItem then
    if Pos('&Open...', TActionClientItem(AClient).Caption) <> 0 then
      FOpenToolItem := AClient as TActionClientItem;
end;

procedure TMainForm.FindReopenMenuItem(AClient: TActionClient);
begin
  // Find the Reopen item by looking at the item caption
  if AClient is TActionClientItem then
    if Pos('Reopen', TActionClientItem(AClient).Caption) <> 0 then
      FReopenMenuItem := AClient as TActionClientItem
end;

procedure TMainForm.ForgetHttpProxyPwd(Sender: TObject);
begin
  with UserPreferences do begin
    HttpProxyUsername := '';
    HttpProxyPassword := '';
  end;
end;

function TMainForm.GetApplicationDataFolder: string;
var
  Path: array[0..MAX_PATH] of Char;
begin
  Result := '';
  FillChar(Path, SizeOf(Path), 0);
  if SHGetFolderPath(0, CSIDL_APPDATA or CSIDL_FLAG_CREATE, 0, 0, Path) = S_OK then
    Result := Path;
end;

function TMainForm.GetDataFolder: string;
begin
  Result := GetApplicationDataFolder + '\Open XML Editor';
end;

function TMainForm.GetIniFileName: string;
begin
  Result := GetDataFolder + '\settings.ini';
end;

function TMainForm.OpenFile(AFileName: string): Boolean;
var
  CursorBackup: TCursor;
begin
  CursorBackup := Screen.Cursor;
  Screen.Cursor := crHourGlass; // Show hourglass cursor
  try
    Result := OpenUri(FilenameToUriWideStr(ExpandFileName(AFileName), []));
  finally
    Screen.Cursor := CursorBackup; // Restore cursor
  end;
end;

procedure TMainForm.OpenFiles(const Files: TStrings);
var
  I: Integer;
  LastNonWellformedFile: TXmlEditTabSheet;
begin
  with Files do begin
    LastNonWellformedFile := nil;
    for I := 0 to Pred(Count) do
      if OpenFile(Strings[I]) then
        if Assigned(XmlEditPageControl.ActivePage) then
          if not XmlEditPageControl.ActivePage.IsWellformed then
            LastNonWellformedFile := XmlEditPageControl.ActivePage;
    // Activate the last page containing a non-wellformed XML file.
    if Assigned(LastNonWellformedFile) then
      XmlEditPageControl.ActivePage := LastNonWellformedFile;
  end;
end;

function TMainForm.OpenUri(SysId: WideString): Boolean;
var
  CursorBackup: TCursor;
begin
  if SysId = '' then begin
    // Open a new editor tab sheet:
    XmlEditPageControl.AddEmptyDoc;
    Result := True;
  end else begin
    // Activates the editor if the file is already open:
    if XmlEditPageControl.ActivatePage(SysId) then begin
      Result := True;
      Exit;
    end;

    CursorBackup := Screen.Cursor;
    Screen.Cursor := crHourGlass; // Show hourglass cursor
    try
      Result := XmlEditPageControl.OpenUri('', SysId);
    finally
      Screen.Cursor := CursorBackup; // Restore cursor
    end;

    // Update MRU entries:
    if Result then begin
      AddMRUEntry(SysId)
    end else begin
      RemoveMRUEntry(SysId);
      MessageBeep(MB_ICONEXCLAMATION);
      ShowMessage(Format(SNotFound, [SysId]));
    end;

  end;
end;

procedure TMainForm.ReadIniSettings;
var
  IniFile: TIniFile;
  I, L, T, W, H: Integer;
  S: string;
  Stream: TStringStream;
  SearchParams: TXmlSearchParams;
begin
  IniFile := TIniFile.Create(GetIniFileName);
  try
    // Form properties:
    L := IniFile.ReadInteger('Main', 'Left', 0);
    T := IniFile.ReadInteger('Main', 'Top', 0);
    W := IniFile.ReadInteger('Main', 'Width', 0);
    H := IniFile.ReadInteger('Main', 'Height', 0);
    if (W > 0) and (H > 0) then
      SetBounds(L, T, W, H);
    if IniFile.ReadBool('Main', 'Maximized', False) then
      WindowState := wsMaximized;
    StatusBar.Visible := IniFile.ReadBool('Main', 'ShowStatusbar', True);
    MessageAutoListBox.Height := IniFile.ReadInteger('Main', 'MessageBoxHeight', 100);
    ToolsPageControl.Width := IniFile.ReadInteger('Main', 'ToolsControlWidth', ToolsControlSplitter.MinSize);
    ToolsControlSplitter.Visible := IniFile.ReadBool('Main', 'ShowToolsControl', True);
    ToolsPageControl.Visible := IniFile.ReadBool('Main', 'ShowToolsControl', True);
    // Remark: Visibility of ToolsControlSplitter must be set before ToolsPageControl,
    //         because of TSplitter adjustment bug in Delphi 7.  (Otherwise, an
    //         invisible Splitter is automatically moved to the left of the
    //         PageControl.)

    // MRU files:
    // Find the Reopen... menu item on the ActionMainMenu:
    ActionManager.ActionBars.IterateClients(ActionManager.ActionBars[0].Items,
      FindReopenMenuItem);
    // Find the Reopen... menu item on the ActionToolBar:
    ActionManager.ActionBars.IterateClients(ActionManager.ActionBars[1].Items,
      FindOpenToolItem);
    // Assign the file names:
    for I := 9 downto 0 do begin
      S := IniFile.ReadString('MRUFiles', Format('MRUFile%d', [I]), '');
      AddMRUEntry(S);
    end;

    // Editor font settings:
    XmlEditPageControl.EditorFont.Name := IniFile.ReadString('Font', 'Name', 'Courier New');
    XmlEditPageControl.EditorFont.Size := IniFile.ReadInteger('Font', 'Size', 10);

    // Version control:
    UserPreferences.CheckForUpdate := IniFile.ReadBool('VersionControl', 'On', True);
    FVCFirstAttempt := IniFile.ReadBool('VersionControl', 'FirstAttempt', True);

    // Proxy settings:
    with UserPreferences do begin
      UseProxies := IniFile.ReadBool('Preferences', 'UseProxies', False);
      HttpProxy := IniFile.ReadString('Preferences', 'HttpProxy', '');
      HttpProxyPassword := IniFile.ReadString('Preferences', 'HttpProxyPassword', '');
      HttpProxyPort := IniFile.ReadInteger('Preferences', 'HttpProxyPort', 0);
      HttpProxyUsername := IniFile.ReadString('Preferences', 'HttpProxyUsername', '');
      StoreHttpProxyPassword := IniFile.ReadInteger('Preferences', 'StoreHttpProxyPassword', 1);
    end;

    // Tools settings:
    XmlEditPageControl.ExternalHexEditor := IniFile.ReadString('Preferences', 'HexEditor', '');
    XmlEditPageControl.Saxon := IniFile.ReadString('Preferences', 'Saxon', '');

    // Search parameter:
    with SearchParams do begin
      SearchBackwards := False;
      SearchCaseSensitive := IniFile.ReadBool('Search', 'CaseSensitive', False);
      SearchFromCaret := True;
      SearchFromCursor := IniFile.ReadBool('Search', 'FromCursor', True);
      SearchSelectionOnly := False;
      SearchTextAtCaret := True;
      SearchWholeWords := IniFile.ReadBool('Search', 'WholeWords', False);

      SearchText := '';
      ReplaceText := '';
      // Remark: Must use Stream, because string contains line breaks:
      Stream := TStringStream.Create('');
      try
        IniFile.ReadBinaryStream('Search', 'SearchTextHistory', Stream);
        SearchTextHistory := Stream.DataString;
      finally
        Stream.Free;
      end;
      Stream := TStringStream.Create('');
      try
        IniFile.ReadBinaryStream('Search', 'ReplaceTextHistory', Stream);
        ReplaceTextHistory := Stream.DataString;
      finally
        Stream.Free;
      end;
    end;
    XmlEditPageControl.SearchParams := SearchParams;

  finally
    IniFile.Free;
  end;
end;

procedure TMainForm.ReadPublicIdMappings;
begin
  // xxx To do.
end;

procedure TMainForm.RemoveMRUEntry(const S: string);
var
  I, N, R: Integer;
begin
  if S = '' then Exit;
  // Remove thew specified filename from the list and move other items up:
  R := -1;
  N := -1;
  with ReopenActionList do begin
    repeat
      Inc(N);
      if CompareText(TCustomAction(Actions[N]).Caption, S) = 0 then begin
        R := N;
        Break;
      end;
    until N = Pred(ActionCount);

    if R > -1 then begin
      for I := R to ActionCount - 2 do
        TCustomAction(Actions[I]).Caption := TCustomAction(Actions[I + 1]).Caption;
      TCustomAction(Actions[Pred(ActionCount)]).Caption := '';
    end;
  end;
  // Update the menu entries:
  UpdateReopenItem(FReopenMenuItem);
//UpdateReopenItem(FOpenToolItem);  // xxx Disabled, because due to a bug in Delphi 7 the button is not rendered correctly.
end;

procedure TMainForm.ShowPreferencesDlg(const AActivePageIndex: Integer);
var
  PreferencesDlg: TPreferencesDlg;
  IniFile: TIniFile;
begin
  PreferencesDlg := TPreferencesDlg.Create(Self);
  try
    with PreferencesDlg do
    begin
      EditorFont := XmlEditPageControl.EditorFont;
      CheckForUpdateAction := actHelpCheckNewVersion;
      OnForgetPwd := ForgetHttpProxyPwd;
      CheckForUpdate := UserPreferences.CheckForUpdate;
      UseProxies := UserPreferences.UseProxies;
      HttpProxy := UserPreferences.HttpProxy;
      HttpProxyPort := UserPreferences.HttpProxyPort;
      ForgetProxyPasswordBtn.Enabled := (UserPreferences.HttpProxyUsername <> '') or (UserPreferences.HttpProxyPassword <> '');
      StoreHttpProxyPassword := UserPreferences.StoreHttpProxyPassword;
      HexEditor := XmlEditPageControl.ExternalHexEditor;
      Saxon := XmlEditPageControl.Saxon;

      MainPageControl.ActivePageIndex := Min(AActivePageIndex, Pred(MainPageControl.PageCount));
      if ShowModal = mrOK then
      begin
        XmlEditPageControl.EditorFont := EditorFont;
        UserPreferences.CheckForUpdate := CheckForUpdate;
        UserPreferences.UseProxies := UseProxies;
        UserPreferences.HttpProxy := HttpProxy;
        UserPreferences.HttpProxyPort := HttpProxyPort;
        if UserPreferences.StoreHttpProxyPassword <> StoreHttpProxyPassword then
        begin
          UserPreferences.StoreHttpProxyPassword := StoreHttpProxyPassword;
          if StoreHttpProxyPassword <> 0 then
          begin
            // Immediately delete the password from the Ini-file:
            IniFile := TIniFile.Create(GetIniFileName);
            try
              IniFile.WriteInteger('Preferences', 'StoreHttpProxyPassword', StoreHttpProxyPassword);
              IniFile.WriteString('Preferences', 'HttpProxyUsername', '');
              IniFile.WriteString('Preferences', 'HttpProxyPassword', '');
            finally
              IniFile.Free;
            end;
            if StoreHttpProxyPassword = 2 then
            begin
              UserPreferences.HttpProxyUsername := '';
              UserPreferences.HttpProxyPassword := '';
            end;
          end;
        end;
        UpdateProxySetting;
        XmlEditPageControl.ExternalHexEditor := HexEditor;
        XmlEditPageControl.Saxon := Saxon;
      end;
    end;
  finally
    PreferencesDlg.Free;
  end;
end;

procedure TMainForm.UpdateProxySetting;
begin
  with IndyResourceResolver.ProxyParams do begin
    if UserPreferences.UseProxies then begin
      ProxyServer := UserPreferences.HttpProxy;
      ProxyPassword := UserPreferences.HttpProxyPassword;
      ProxyPort := UserPreferences.HttpProxyPort;
      ProxyUsername := UserPreferences.HttpProxyUsername;
    end else begin
      ProxyPassword := '';
      ProxyPort := 0;
      ProxyServer := '';
      ProxyUsername := '';
    end;
  end;
end;

procedure TMainForm.UpdateReopenItem(const ReopenItem: TActionClientItem);
var
  I, N: Integer;
begin
  // Determine the number of MURFiles:
  N := ReopenActionList.ActionCount;
  for I := 0 to Pred(ReopenActionList.ActionCount) do
    if TCustomAction(ReopenActionList.Actions[I]).Caption = '' then begin
      N := I;
      Break;
    end;
  // Add new items to the reopen item if necessary
  while ReopenItem.Items.Count < N do
    ReopenItem.Items.Add;
  // Remove new items from the reopen item if necessary
  while ReopenItem.Items.Count > N do
    ReopenItem.Items.Delete(0);
  // Set the item captions by appending a number for use as the shortcut
  for I := 0 to Pred(ReopenItem.Items.Count) do begin
    ReopenItem.Items[I].Action := ReopenActionList.Actions[I];
    ReopenItem.Items[I].Caption := Format('&%d: %s', [I,
      TCustomAction(ReopenActionList.Actions[I]).Caption]);
  end;
end;

procedure TMainForm.VersionCheckerCompleted(Sender: TObject;
  VCResult: TVersionCheckerResult);
begin
  if VCResult in [ vrNewVersion, vrNoNewVersion ] then
    FVCFirstAttempt := False;
end;

procedure TMainForm.WriteIniSettings;
var
  I: Integer;
  IniFile: TIniFile;
  WP: TWindowPlacement;
  Stream: TStringStream;
begin
  IniFile := TIniFile.Create(GetIniFileName);
  try
    WP.Length := SizeOf(TWindowPlacement);
    GetWindowPlacement(Handle, @WP);

    // Form properties:
    with WP.rcNormalPosition do begin
      IniFile.WriteInteger('Main', 'Left', Left);
      IniFile.WriteInteger('Main', 'Top', Top);
      IniFile.WriteInteger('Main', 'Width', Right - Left);
      IniFile.WriteInteger('Main', 'Height', Bottom - Top);
    end;
    IniFile.WriteBool('Main', 'Maximized', WindowState = wsMaximized );
    IniFile.WriteBool('Main', 'ShowStatusbar', Statusbar.Visible);
    IniFile.WriteInteger('Main', 'MessageBoxHeight', MessageAutoListBox.Height);
    IniFile.WriteInteger('Main', 'ToolsControlWidth', ToolsPageControl.Width);
    IniFile.WriteBool('Main', 'ShowToolsControl', ToolsPageControl.Visible);

    // MRU files:
    with ReopenActionList do
      for I := 0 to Pred(ActionCount) do
        IniFile.WriteString('MRUFiles',
                            Format('MRUFile%d', [I]),
                            TCustomAction(Actions[I]).Caption);

    // Editor font settings:
    IniFile.WriteString('Font', 'Name', XmlEditPageControl.EditorFont.Name);
    IniFile.WriteInteger('Font', 'Size', XmlEditPageControl.EditorFont.Size);

    // Version Control:
    IniFile.WriteBool('VersionControl', 'On', UserPreferences.CheckForUpdate);
    IniFile.WriteBool('VersionControl', 'FirstAttempt', FVCFirstAttempt);

    // Proxy settings:
    with UserPreferences do begin
      IniFile.WriteBool('Preferences', 'UseProxies', UseProxies);
      IniFile.WriteString('Preferences', 'HttpProxy', HttpProxy);
      IniFile.WriteInteger('Preferences', 'HttpProxyPort', Max(HttpProxyPort, 0));
      IniFile.WriteInteger('Preferences', 'StoreHttpProxyPassword', StoreHttpProxyPassword);
      if StoreHttpProxyPassword = 0 then begin
        IniFile.WriteString('Preferences', 'HttpProxyUsername', HttpProxyUsername);
        IniFile.WriteString('Preferences', 'HttpProxyPassword', HttpProxyPassword);
      end else begin
        IniFile.WriteString('Preferences', 'HttpProxyUsername', '');
        IniFile.WriteString('Preferences', 'HttpProxyPassword', '');
      end;
    end;

    // Tools settings:
    IniFile.WriteString('Preferences', 'HexEditor', XmlEditPageControl.ExternalHexEditor);
    IniFile.WriteString('Preferences', 'Saxon', XmlEditPageControl.Saxon);

    // Search parameter:
    with XmlEditPageControl.SearchParams do begin
      IniFile.WriteBool('Search', 'CaseSensitive', SearchCaseSensitive);
      IniFile.WriteBool('Search', 'FromCursor', SearchFromCursor);
      IniFile.WriteBool('Search', 'WholeWords', SearchWholeWords);

      // Remark: Must use Stream, because string contains line breaks:
      Stream := TStringStream.Create(SearchTextHistory);
      try
        IniFile.WriteBinaryStream('Search', 'SearchTextHistory', Stream);
      finally
        Stream.Free;
      end;
      Stream := TStringStream.Create(ReplaceTextHistory);
      try
        IniFile.WriteBinaryStream('Search', 'ReplaceTextHistory', Stream);
      finally
        Stream.Free;
      end;
    end;
  finally
    IniFile.Free;
  end;
end;

// Action handler methods

procedure TMainForm.actCheckValidityExecute(Sender: TObject);
var
  CursorBackup: TCursor;
  Ok: Boolean;
begin
  CursorBackup := Screen.Cursor;
  Screen.Cursor := crHourGlass; // Show hourglass cursor
  try
    Ok := XmlEditPageControl.CheckValidity;
  finally
    Screen.Cursor := CursorBackup; // Restore cursor
  end;
  if Ok
    then ShowMessage(SIsValid)
    else ShowMessage(SIsNotValid);
  AutoShowMessagePanel;
  CaretMoveToError;
end;

procedure TMainForm.actCheckValidityUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanCheckValidity;
end;

procedure TMainForm.actCheckWellformednessExecute(
  Sender: TObject);
var
  CursorBackup: TCursor;
  Ok: Boolean;
begin
  CursorBackup := Screen.Cursor;
  Screen.Cursor := crHourGlass; // Show hourglass cursor
  try
    Ok := XmlEditPageControl.CheckWellformedness;
  finally
    Screen.Cursor := CursorBackup; // Restore cursor
  end;
  if Ok
    then ShowMessage(SIsWellformed)
    else ShowMessage(SIsNotWellformed);
  AutoShowMessagePanel;
  CaretMoveToError;
end;

procedure TMainForm.actCheckWellformednessUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanCheckWellformedness;
end;

procedure TMainForm.actFileCloseExecute(Sender: TObject);
begin
  XmlEditPageControl.Close;
  AutoShowMessagePanel;
end;

procedure TMainForm.actFileCloseUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.HasActivePage;
end;

procedure TMainForm.actFileCloseAllExecute(Sender: TObject);
begin
  with XmlEditPageControl do
    if CanCloseAll then  
      CloseAll;
  AutoShowMessagePanel;
end;

procedure TMainForm.actFileCloseAllUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.HasActivePage;
end;

procedure TMainForm.actFileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.actFileNewUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := True;
end;

procedure TMainForm.actFileNewExecute(Sender: TObject);
begin
  XmlEditPageControl.AddEmptyDoc;
  AutoShowMessagePanel;
end;

procedure TMainForm.actFileOpenUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := True;
end;

procedure TMainForm.actFileOpenExecute(Sender: TObject);
begin
  with OpenDialog do begin
    Filter := SFilterMaskXmlFiles + '|' + SFilterMaskAllFiles;
    if Execute then
      OpenFiles(Files);
  end;
  AutoShowMessagePanel;
  CaretMoveToError;
end;

procedure TMainForm.actFilePageSetupExecute(Sender: TObject);
begin
  XmlEditPageControl.PageSetup;
end;

procedure TMainForm.actFilePageSetupUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := True;
end;

procedure TMainForm.actFilePrinterSetupExecute(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;

procedure TMainForm.actFilePrinterSetupUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := True;
end;

procedure TMainForm.actFilePrintPreviewExecute(Sender: TObject);
begin
  XmlEditPageControl.PrintPreview;
end;

procedure TMainForm.actFilePrintPreviewUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanPrint;
end;

procedure TMainForm.actFilePrintExecute(Sender: TObject);
begin
  XmlEditPageControl.Print;
end;

procedure TMainForm.actFilePrintUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanPrint;
end;

procedure TMainForm.actFileReloadExecute(Sender: TObject);
const
  MBType = MB_YESNO or MB_ICONQUESTION;
var
  CursorBackup: TCursor;
  Ok: Boolean;
begin
  if Application.MessageBox(PChar(SAskReload), PChar(Application.Title), MBType) = IDNo then
    Exit;

  CursorBackup := Screen.Cursor;
  Screen.Cursor := crHourGlass; // Show hourglass cursor
  try
    Ok := XmlEditPageControl.Reload;
  finally
    Screen.Cursor := CursorBackup; // Restore cursor
  end;

  if not Ok then ShowMessage(SReloadFailed);
end;

procedure TMainForm.actFileReloadUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    if Assigned(XmlEditPageControl.ActivePage) then
      (Sender as TCustomAction).Enabled := XmlEditPageControl.ActivePage.DocumentUri <> '';
end;

procedure TMainForm.actFileReopenExecute(Sender: TObject);
begin
  if Sender is TCustomAction then begin
    OpenUri((Sender as TCustomAction).Caption);
    AutoShowMessagePanel;
    CaretMoveToError;
  end;
end;

procedure TMainForm.actFileSaveExecute(Sender: TObject);
begin
  XmlEditPageControl.Save;
  AutoShowMessagePanel;
  CaretMoveToError;
end;

procedure TMainForm.actFileSaveUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanSave;
end;

procedure TMainForm.actFileSaveAsExecute(Sender: TObject);
begin
  XmlEditPageControl.SaveAs;
  AutoShowMessagePanel;
  CaretMoveToError;
end;

procedure TMainForm.actFileSaveAsUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanSaveAs;
end;

procedure TMainForm.actEditCutExecute(Sender: TObject);
begin
  XmlEditPageControl.CutToClipboard;
end;

procedure TMainForm.actEditCutUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanCut;
end;

procedure TMainForm.actEditCopyExecute(Sender: TObject);
begin
  XmlEditPageControl.CopyToClipboard;
end;

procedure TMainForm.actEditCopyUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanCopy;
end;

procedure TMainForm.actEditPasteExecute(Sender: TObject);
begin
  XmlEditPageControl.PasteFromClipboard;
end;

procedure TMainForm.actEditPasteUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanPaste;
end;

procedure TMainForm.actEditDeleteExecute(Sender: TObject);
begin
  XmlEditPageControl.DeleteSelection;
end;

procedure TMainForm.actEditDeleteUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanDelete;
end;

procedure TMainForm.actEditSelectAllExecute(Sender: TObject);
begin
  XmlEditPageControl.SelectAll;
end;

procedure TMainForm.actEditSelectAllUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanSelectAll;
end;

procedure TMainForm.actEditRedoExecute(Sender: TObject);
begin
  XmlEditPageControl.Redo;
end;

procedure TMainForm.actEditRedoUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanRedo;
end;

procedure TMainForm.actEditUndoExecute(Sender: TObject);
begin
  XmlEditPageControl.Undo;
end;

procedure TMainForm.actEditUndoUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanUndo;
end;

procedure TMainForm.actSearchFindExecute(Sender: TObject);
begin
  XmlEditPageControl.Find;
end;

procedure TMainForm.actSearchFindUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanSearch;
end;

procedure TMainForm.actSearchFindNextExecute(Sender: TObject);
begin
  XmlEditPageControl.FindNext;
end;

procedure TMainForm.actSearchFindNextUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanSearch and
                                           (XmlEditPageControl.SearchParams.SearchText <> '');
end;

procedure TMainForm.actSearchFindPrevExecute(Sender: TObject);
begin
  XmlEditPageControl.FindPrev;
end;

procedure TMainForm.actSearchFindPrevUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanSearch and
                                           (XmlEditPageControl.SearchParams.SearchText <> '');
end;

procedure TMainForm.actSearchReplaceExecute(Sender: TObject);
begin
  XmlEditPageControl.Replace;
end;

procedure TMainForm.actSearchReplaceUpdate(Sender: TObject);
begin
  if Sender is TCustomAction then
    (Sender as TCustomAction).Enabled := XmlEditPageControl.CanReplace;
end;

procedure TMainForm.actUpdateStatusBarPanelsUpdate(Sender: TObject);
begin
  actUpdateStatusBarPanels.Enabled := TRUE;
  if Assigned(XmlEditPageControl.ActivePage) then begin
    StatusBar.Panels[0].Text := XmlEditPageControl.CaretPosStr;
    if XmlEditPageControl.ActivePage.Modified then
      StatusBar.Panels[1].Text := SModified
    else
      StatusBar.Panels[1].Text := '';
    StatusBar.Panels[2].Text := XmlEditPageControl.ActivePage.EditorState;
    StatusBar.Panels[3].Text := XmlEditPageControl.ActivePage.MimeType;
    if XmlEditPageControl.SaxonIsBusy then
      StatusBar.Panels[4].Text := SXsltRunning
    else
      StatusBar.Panels[4].Text := '';
  end else begin
    StatusBar.Panels[0].Text := '';
    StatusBar.Panels[1].Text := '';
    StatusBar.Panels[2].Text := '';
    StatusBar.Panels[3].Text := '';
    StatusBar.Panels[4].Text := '';
  end;
end;

procedure TMainForm.actViewButtonBarExecute(Sender: TObject);
begin
  ButtonBar.Visible := not ButtonBar.Visible;
end;

procedure TMainForm.actViewButtonBarUpdate(Sender: TObject);
begin
  actViewButtonbar.Checked := ButtonBar.Visible;
end;

procedure TMainForm.actViewFileSystemExplorerExecute(Sender: TObject);
begin
  ToolsPageControl.Visible := not ToolsPageControl.Visible;
  ToolsControlSplitter.Visible := not ToolsControlSplitter.Visible;
end;

procedure TMainForm.actViewFileSystemExplorerUpdate(Sender: TObject);
begin
  actViewFileSystemExplorer.Checked := ToolsPageControl.Visible;
end;

procedure TMainForm.actViewMessagesExecute(Sender: TObject);
begin
  MessageAutoListBox.Visible := not MessageAutoListBox.Visible;
  MainPanelSplitter.Visible := not MainPanelSplitter.Visible;
end;

procedure TMainForm.actViewMessagesUpdate(Sender: TObject);
begin
  actViewMessages.Checked := MessageAutoListBox.Visible;
end;

procedure TMainForm.actViewStatusBarExecute(Sender: TObject);
begin
  StatusBar.Visible := not StatusBar.Visible;
end;

procedure TMainForm.actViewStatusBarUpdate(Sender: TObject);
begin
  actViewStatusBar.Checked := StatusBar.Visible;
end;

procedure TMainForm.actViewPreferencesExecute(Sender: TObject);
begin
  ShowPreferencesDlg(0);
end;

procedure TMainForm.actHelpAboutExecute(Sender: TObject);
var
  AboutBox: TAboutBox;
begin
  AboutBox := TAboutBox.Create(Self);
  try
    AboutBox.ShowModal;
  finally
    AboutBox.Free;
  end;
end;

procedure TMainForm.actHelpAboutUpdate(Sender: TObject);
begin
  actHelpAbout.Enabled := True;
end;

procedure TMainForm.actHelpCheckNewVersionExecute(Sender: TObject);
begin
  with VersionChecker do begin
    Options := [ voNewVersionMsg, voNoNewVersionMsg, voErrorMsg ];
    CheckVersion(FVCFirstAttempt);
  end;
end;

procedure TMainForm.actHelpCheckNewVersionUpdate(Sender: TObject);
begin
  actHelpCheckNewVersion.Enabled := True;
end;

procedure TMainForm.actLaunchSaxonExecute(Sender: TObject);
begin
  XmlEditPageControl.LaunchSaxon;
end;

procedure TMainForm.actLaunchSaxonUpdate(Sender: TObject);
begin
  actLaunchSaxon.Enabled := (Trim(XmlEditPageControl.Saxon) <> '') and
    not XmlEditPageControl.SaxonIsBusy;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  Realign; // Necessary for correct alignment of the ButtonBar.
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  XmlEditPageControl.FocusEditor;

  if UserPreferences.CheckForUpdate then
    with VersionChecker do begin
      Options := [ voNewVersionMsg ];
      CheckVersion(FVCFirstAttempt);
    end;
end;

procedure TMainForm.ApplicationEventsActivate(Sender: TObject);
begin
  XmlEditPageControl.CheckRefreshActivePage;
end;

procedure TMainForm.VirtualShellTreeFileDblClick(Sender: TObject;
  FullPath: WideString; Attributes: Cardinal);
begin
  OpenFile(FullPath);
end;

end.
